<template>
  <div>

    <!-- Date Input -->
    <date-field
      v-if="field.type === 'date'"
      :field="field"
      v-model="data[field.id]"
    />
    <enum-field
      v-else-if="field.type === 'enum'"
      :field="field"
      v-model="data[field.id]"
    />
    <text-field
      v-else
      :field="field"
      v-model="data[field.id]"
    />

  </div>
</template>

<script lang="ts">
import Vue from 'vue'
import DateField from './field/DateField.vue'
import EnumField from './field/EnumField.vue'
import TextField from './field/TextField.vue'

export default Vue.extend({
  name: 'form-field',
  components: { DateField, EnumField, TextField },
  props: {
    field: { type: Object, required: true },
    data: { type: Object, required: true }
  },
  data () {
    return {
      menu: false
    }
  },
  watch: {
    menu (val) {
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      val && setTimeout(() => ((this.$refs.picker as any).activePicker = 'YEAR'))
    }
  }
})
</script>
